#ifndef CONSOLE_H_INCLUDED
#define CONSOLE_H_INCLUDED

#include "typedef.h"
#include "vsurface.h"

#define	FSIZE		(6)	// ptHg̕

// F`
#if INBPP == 8	// 8bit

#define	FC_BLACK	0
#define	FC_DBLUE	1
#define	FC_DGREEN	2
#define	FC_DCYAN	3
#define	FC_DRED		4
#define	FC_DMAGENTA	5
#define	FC_DYELLOW	6
#define	FC_GRAY		7
#define	FC_DGRAY	8
#define	FC_BLUE		9
#define	FC_GREEN	10
#define	FC_CYAN		11
#define	FC_RED		12
#define	FC_MAGENTA	13
#define	FC_YELLOW	14
#define	FC_WHITE	15

#else			// 32bit

#define	FC_BLACK	0x00000000
#define	FC_DBLUE	(0x7f7f7f7f &  BMASK32)
#define	FC_DGREEN	(0x7f7f7f7f &  GMASK32)
#define	FC_DCYAN	(0x7f7f7f7f & (GMASK32|BMASK32))
#define	FC_DRED		(0x7f7f7f7f &  RMASK32)
#define	FC_DMAGENTA	(0x7f7f7f7f & (RMASK32|BMASK32))
#define	FC_DYELLOW	(0x7f7f7f7f & (RMASK32|GMASK32))
#define	FC_GRAY		(0x7f7f7f7f & (RMASK32|GMASK32|BMASK32))
#define	FC_DGRAY	(0x3f3f3f3f & (RMASK32|GMASK32|BMASK32))
#define	FC_BLUE		(0xffffffff &  BMASK32)
#define	FC_GREEN	(0xffffffff &  GMASK32)
#define	FC_CYAN		(0xffffffff & (GMASK32|BMASK32))
#define	FC_RED		(0xffffffff &  RMASK32)
#define	FC_MAGENTA	(0xffffffff & (RMASK32|BMASK32))
#define	FC_YELLOW	(0xffffffff & (RMASK32|GMASK32))
#define	FC_WHITE	(0xffffffff & (RMASK32|GMASK32|BMASK32))

#endif



////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class JFont {
protected:
	static VSurface *ZFont;		// SptHgf[^T[tFXւ̃|C^
	static VSurface *HFont;		// ptHgf[^T[tFXւ̃|C^
	
	static int zWidth, zHeight;	// Sp̕,
	static int hWidth, hHeight;	// p̕,
	
public:
	JFont();									// RXgN^
	~JFont();									// fXgN^
	
	static bool OpenFont( char *, char * );		// t@Ct@CJ
	static void CloseFont();					// tHgj
	
	static int FontWidth(){ return hWidth; }	// tHg̕擾(p)
	static int FontHeight(){ return hHeight; }	// tHg̍擾
	
	#if INBPP == 8	// 8bit
	void PutCharh( VSurface *, int, int, BYTE, BYTE,  BYTE  );	// p`
	void PutCharz( VSurface *, int, int, WORD, BYTE,  BYTE  );	// Sp`
	#else			// 32bit
	void PutCharh( VSurface *, int, int, BYTE, DWORD, DWORD );	// p`
	void PutCharz( VSurface *, int, int, WORD, DWORD, DWORD );	// Sp`
	#endif

};


class ZCons : public JFont, public VSurface {
protected:
	VRect con;					// `͈
	int Xmax,Ymax;				// cő啶(p)
	int x,y;					// J[\ʒu
	#if INBPP == 8	// 8bit
	BYTE fgc,bgc;				// `FƔwiF
	#else			// 32bit
	DWORD fgc,bgc;				// `FƔwiF
	#endif
	char Caption[129];			// LvV
	
	void DrawFrame();							// g`
	void ScrollUp();							// XN[Abv
	
public:
	ZCons();									// RXgN^
	virtual ~ZCons();							// fXgN^
	
	#if INBPP == 8	// 8bit
	bool Init   ( int, int, const char *, BYTE =FC_WHITE, BYTE =FC_BLACK );	// (ŃTCYw)
	bool InitRes( int, int, const char *, BYTE =FC_WHITE, BYTE =FC_BLACK );	// (𑜓xŃTCYw)
	void SetColor( BYTE, BYTE );				// `Fݒ
	void SetColor( BYTE );
	#else			// 32bit
	bool Init   ( int, int, const char *, DWORD=FC_WHITE, DWORD=FC_BLACK );	// (ŃTCYw)
	bool InitRes( int, int, const char *, DWORD=FC_WHITE, DWORD=FC_BLACK );	// (𑜓xŃTCYw)
	void SetColor( DWORD, DWORD );				// `Fݒ
	void SetColor( DWORD );
	#endif
	
	void Locate( int, int );					// J[\ʒuݒ
	void LocateR( int, int );					// J[\ʒuݒ(΍W)
	void Cls();									// ʏ
	
	void PutCharH( BYTE );						// p1`
	void PutCharZ( WORD );						// Sp1`
	
	void Print( const char *, ... );			// t`(䕶Ή)
	void Printf( const char *, ... );			// t`(䕶Ή)
	void Printfr( const char *, ... );			// t`(El)
	
	int GetXline();								// ő啶擾
	int GetYline();								// cő啶擾
};


#endif	// CONSOLE_H_INCLUDED
