#ifndef AY8910_H_INCLUDED
#define AY8910_H_INCLUDED

#include "../typedef.h"
#include "../ini.h"
#include "psgbase.h"

#ifdef USEFMGEN
#include "fmgen/types.h"
#include "fmgen/psg.h"
#endif


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cAY8910 : public cPSG, public virtual IDoko {
protected:
	#ifdef USEFMGEN
	PSG	psg;
	#else
	BYTE Regs[16];
	int UpdateStep;
	int PeriodA, PeriodB, PeriodC, PeriodN, PeriodE;
	int CountA, CountB, CountC, CountN, CountE;
	int VolA, VolB, VolC, VolE;
	BYTE EnvelopeA, EnvelopeB, EnvelopeC;
	BYTE OutputA, OutputB, OutputC, OutputN;
	int8_t CountEnv;
	BYTE Hold,Alternate,Attack,Holding;
	int RNG;
	int VolTable[32];
	#endif
	
	void _WriteReg( BYTE, BYTE );		// WX^݃Tu
	void WriteReg( BYTE, BYTE );		// WX^
	BYTE ReadReg();						// WX^Ǎ
	
	void SetClock( int, int );			// NbNݒ
	void SetVolumeTable( int );			// ʐݒ({[e[uݒ)
	
	void Reset();						// Zbg
	
public:
	cAY8910();							// RXgN^
	virtual ~cAY8910();					// fXgN^
	
	int Update1Sample();				// Xg[1SampleXV
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


#endif	// AY8910_H_INCLUDED
