#ifndef IO_H_INCLUDED
#define IO_H_INCLUDED

#include "typedef.h"
#include "device.h"

// ftHg|[g
#define	BANKSIZE	256


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// ---------------------------------------------------------------------------
//	IOBus : I/OԂ񋟂NX
//	  Original     : cisc
//	  Modification : Yumitaro
// ---------------------------------------------------------------------------
class IOBus {
// ^`
public:
	typedef Device::InFuncPtr InFuncPtr;
	typedef Device::OutFuncPtr OutFuncPtr;
	
	struct InBank{
		IDevice* device;
		InFuncPtr func;
		InBank* next;
	};
	struct OutBank{
		IDevice* device;
		OutFuncPtr func;
		OutBank* next;
	};
	
	enum ConnectRule{
		end = 0, portin = 1, portout = 2
	};
	struct Connector{
		DWORD bank;
		BYTE rule;
		BYTE id;
	};
	
private:
	class DummyIO : public Device{
	public:
		DummyIO() : Device(NULL,0) {}
		~DummyIO() {}
		
		BYTE dummyin( int );
		void dummyout( int, BYTE );
	};

// {
public:
	IOBus();
	~IOBus();
	
	bool Init( DeviceList* devlist = 0, int bs = BANKSIZE );
	
	bool ConnectIn( int bank, IDevice* device, InFuncPtr func );
	bool ConnectOut( int bank, IDevice* device, OutFuncPtr func );
	
	InBank* GetIns() { return ins; }
	OutBank* GetOuts() { return outs; }
	BYTE* GetFlags() { return flags; }
	
	bool Connect( IDevice* device, const Connector* connector );
	bool Disconnect( IDevice* device );
	BYTE In( int port );
	void Out( int port, BYTE data );
	
private:
	InBank* ins;
	OutBank* outs;
	BYTE* flags;
	DeviceList* devlist;
	
	int banksize;
	
	static DummyIO dummyio;
};



class IO6 {
private:
	// IuWFNg|C^
	IOBus *io;								// I/OoX
	DeviceList *dl;							// foCXXg
	
	int Iwait[BANKSIZE];					// IN EFCge[u
	int Owait[BANKSIZE];					// OUTEFCge[u
	
public:
	IO6();									// RXgN^
	~IO6();									// fXgN^
	
	bool Init( int );						// 
	
	bool Connect( IDevice*, const IOBus::Connector* );	// foCXڑ
	bool Disconnect( IDevice* );						// foCXؒf
	
	BYTE In( int, int * = NULL );			// IN֐
	void Out( int, BYTE, int * = NULL );	// OUT֐
	
	void SetInWait( int, int );				// IN EFCgݒ
	void SetOutWait( int, int );			// OUTEFCgݒ
	int GetInWait( int );					// IN EFCg擾
	int GetOutWait( int );					// OUTEFCg擾
};


#endif		// IO_H_INCLUDED
